﻿
using System;
using System.Drawing;
using System.Drawing.Imaging;
using System.Linq;
using System.Threading.Tasks;


namespace exc.jdbi.Pixelmanipulation
{
  public partial class PixelManipulation
  {
    public Bitmap ToGrayScale(Bitmap src)
    {
      var newbitmap = Copy(src);
      unsafe
      {
        var bpp = Image.GetPixelFormatSize(newbitmap.PixelFormat) / 8;
        var rc = new Rectangle(0, 0,
                               newbitmap.Width,
                               newbitmap.Height);

        BitmapData bmdata = newbitmap
                            .LockBits(rc,
                             ImageLockMode.ReadWrite,
                             newbitmap.PixelFormat);

        byte* ptrscan = (byte*)bmdata.Scan0.ToPointer();
        var rwarray = new byte[bmdata.Width * bmdata.Height];

        Parallel.For(0, bmdata.Height,
          y =>
          {
            int icurrentline = y * bmdata.Width;
            byte* currentline = ptrscan + (y * bmdata.Stride);
            for (int x = 0; x < (bpp * bmdata.Width); x += bpp)
            {
              //BGR >> Blue(x) + Green(x+1) + Red(x+2)
              rwarray[icurrentline + x / 4] = (byte)((currentline[x] + currentline[x + 1] +
                                                      currentline[x + 2]) / 3);
              currentline[x] = currentline[x + 1] = currentline[x + 2] = rwarray[icurrentline + x / 4];
            }
          });
        newbitmap.UnlockBits(bmdata);
      }
      return newbitmap;
    }
    public Bitmap ToGrayScale2(Bitmap src)
    {
      var newbitmap = Copy(src);
      unsafe
      {
        var bpp = Image.GetPixelFormatSize(newbitmap.PixelFormat) / 8;
        var rc = new Rectangle(0, 0,
                               newbitmap.Width,
                               newbitmap.Height);

        BitmapData bmdata = newbitmap
                            .LockBits(rc,
                             ImageLockMode.ReadWrite,
                             newbitmap.PixelFormat);

        byte* ptrscan = (byte*)bmdata.Scan0.ToPointer();

        Parallel.For(0, bmdata.Height,
          y =>
          {
            byte* currentline = ptrscan + (y * bmdata.Stride);
            for (int x = 0; x < (bpp * bmdata.Width); x += bpp)
            {
              //Der IL-Generator passt die Variable 'greyvalue' 
              //an die Parallelbedingungen an, da die Variable im
              //Parallelblock deklariert ist.
              //BGR >> Blue(x) + Green(x+1) + Red(x+2)
              var greyvalue = (byte)((currentline[x] + currentline[x + 1] +
                                      currentline[x + 2]) / 3);
              currentline[x] = currentline[x + 1] = currentline[x + 2] = greyvalue;
            }
          });
        newbitmap.UnlockBits(bmdata);
      }
      return newbitmap;
    }
  }
}