﻿
using System.IO;
using System.Drawing;
using SOCR = exc.jdbi.Randoms.SOCR;

namespace exc.jdbi.Pixelmanipulation
{
  public partial class PixelManipulation
  {
    public Color ToPixelColor(string srcfile, int x, int y)
    {
      var fi = new FileInfo(srcfile);
      if (!fi.Exists)
        throw new FileNotFoundException(nameof(srcfile));

      var bm = ToBitmapFile(srcfile);
      return bm.GetPixel(x, y);
    }
    public (Color, Point) ToRngPixelColor(string srcfile)
    {
      var fi = new FileInfo(srcfile);
      if (!fi.Exists)
        throw new FileNotFoundException(nameof(srcfile));

      var bm = ToBitmapFile(srcfile);

      Point rngxy = default;
      rngxy.X = SOCR.Next(0,bm.Width);
      rngxy.Y = SOCR.Next(0,bm.Height);

      return (bm.GetPixel(rngxy.X, rngxy.Y), rngxy);
    }
  }
}