﻿
using System.Drawing;
using System.Drawing.Imaging;
using System.Threading.Tasks;
using SORC = exc.jdbi.Randoms.SOCR;

namespace exc.jdbi.Pixelmanipulation
{
  public partial class PixelManipulation
  {
    public Bitmap ToRngBitmap(int width, int height)
    {
      return this.ToRngBitmap(width, height, PixelFormat.Format32bppArgb);
    }
    public Bitmap ToRngBitmap(int width, int height, PixelFormat format)
    {
      var newbitmap = new Bitmap(width, height, format);
      unsafe
      {
        var bpp = Image.GetPixelFormatSize(newbitmap.PixelFormat) / 8;
        var rc = new Rectangle(0, 0,
                               newbitmap.Width,
                               newbitmap.Height);

        BitmapData bmdata = newbitmap
                            .LockBits(rc,
                             ImageLockMode.ReadWrite,
                             newbitmap.PixelFormat);

        byte* ptrscan = (byte*)bmdata.Scan0.ToPointer();
        var rngarr = new byte[bmdata.Stride * bmdata.Height];
        SORC.NextBytes(rngarr);
        
        Parallel.For(0, bmdata.Height,
          y =>
          {
            int icurrentline = y * bmdata.Width * bpp;
            byte* currentline = ptrscan + (y * bmdata.Stride);
            for (int x = 0; x < (bpp * bmdata.Width); x += bpp)
            {
              //BGR >> Blue(x) + Green(x+1) + Red(x+2)
              currentline[x] = rngarr[icurrentline + x];            // Blue
              currentline[x + 1] = rngarr[icurrentline + x + 1]; ;  // Green
              currentline[x + 2] = rngarr[icurrentline + x + 2]; ;  // Red
              if (4 == bpp) currentline[x + 3] = 255;
            }
          });
        newbitmap.UnlockBits(bmdata);
      }
      return newbitmap;
    }
  }
}
