﻿
using System.IO;
using System.Drawing;
using System.ComponentModel;

namespace exc.jdbi.Pixelmanipulation
{
  public partial class PixelManipulation
  {
    public static Bitmap Copy2(Bitmap src)
    {
      //Deep Clone (Funkst nicht für alles)
      return src.Clone(new Rectangle(0, 0, src.Width, src.Height), src.PixelFormat);
    }
    public static Bitmap Copy(Bitmap src)
    {
      Bitmap result;
      var converter = TypeDescriptor.GetConverter(typeof(Image));
      var bytes = (byte[])converter.ConvertTo(src, typeof(byte[]));
      using (var ms = new MemoryStream(bytes))
      {
        result = (Bitmap)Image.FromStream(ms);
      }
      //foreach (var p in src.PropertyItems)
      //  result.SetPropertyItem(p);
      return result;
    }
    public static Bitmap ToBitmapFile(string srcfilepathname)
    {
      var fi = new FileInfo(srcfilepathname);
      if (!fi.Exists)
        throw new FileNotFoundException(nameof(srcfilepathname));
      using (var fs = new FileStream(srcfilepathname, FileMode.Open))
      {
        return (Bitmap)Image.FromStream(fs, true, true);
      }
    }
    public static void SaveBitmap(Bitmap src, string dstfilepathname, bool _deleteexist)
    {
      var fi = new FileInfo(dstfilepathname);
      if (fi.Exists && _deleteexist)
        fi.Delete();
      src.Save(dstfilepathname);
    }
  }
}


