﻿Option Strict On
Option Explicit On

Imports System.Linq
Imports System.Drawing
Imports System.Drawing.Imaging
Imports System.Runtime.InteropServices

Namespace exc.jdbi.vb.Pixelmanipulation
   Partial Public Class PixelManipulation
      Public Function ToGrayScale(src As Bitmap) As Bitmap
         Dim newbitmap = Copy(src)
         Dim bpp = Image.GetPixelFormatSize(newbitmap.PixelFormat) \ 8
         Dim rc = New Rectangle(0, 0,
                                newbitmap.Width,
                                newbitmap.Height)
         Dim bmdata = newbitmap.LockBits(rc,
                                ImageLockMode.ReadWrite,
                                newbitmap.PixelFormat)
         Dim ptrscan = bmdata.Scan0

         Dim bytes = New Byte(bmdata.Stride * bmdata.Height - 1) {}
         Dim rwarray = New Byte(bmdata.Width * bmdata.Height - 1) {}
         Marshal.Copy(ptrscan, bytes, 0, bytes.Length)

         'positionyx = y * width * bbp + x * bbp
         Parallel.For(0, bmdata.Height,
            Sub(y)
               Dim currentline = y * bmdata.Width * bpp
               For x As Int32 = 0 To bmdata.Width - 1
                  Dim b = bytes(currentline + (x * bpp))
                  Dim g = bytes(currentline + (x * bpp) + 1)
                  Dim r = bytes(currentline + (x * bpp) + 2)
                  rwarray(currentline \ bpp + x) = Convert.ToByte((CInt(b) + g + r) \ 3I)
                  bytes(currentline + (x * bpp)) = rwarray(currentline \ bpp + x)
                  bytes(currentline + (x * bpp) + 1) = rwarray(currentline \ bpp + x)
                  bytes(currentline + (x * bpp) + 2) = rwarray(currentline \ bpp + x)
               Next
            End Sub)
         Marshal.Copy(bytes, 0, ptrscan, bytes.Length)
         newbitmap.UnlockBits(bmdata)
         Return newbitmap
      End Function
      Public Function ToGrayScale2(src As Bitmap) As Bitmap
         Dim newbitmap = Copy(src)
         Dim bpp = Image.GetPixelFormatSize(newbitmap.PixelFormat) \ 8
         Dim rc = New Rectangle(0, 0,
                                newbitmap.Width,
                                newbitmap.Height)
         Dim bmdata = newbitmap.LockBits(rc,
                                ImageLockMode.ReadWrite,
                                newbitmap.PixelFormat)
         Dim ptrscan = bmdata.Scan0

         Dim bytes = New Byte(bmdata.Stride * bmdata.Height - 1) {}
         Marshal.Copy(ptrscan, bytes, 0, bytes.Length)
         'positionyx = y * width * bbp + x * bbp
         Parallel.For(0, bmdata.Height,
            Sub(y)
               Dim currentline = y * bmdata.Width * bpp
               For x As Int32 = 0 To bmdata.Width - 1
                  Dim b = bytes(currentline + (x * bpp))
                  Dim g = bytes(currentline + (x * bpp) + 1)
                  Dim r = bytes(currentline + (x * bpp) + 2)
                  'Die Variable 'greyvalue' wird vom IL-Generator
                  'parallelbezogen angepasst, da sie in diesem Block
                  'deklariert ist.
                  Dim greyvalue = Convert.ToByte((CInt(b) + g + r) \ 3I)
                  bytes(currentline + (x * bpp)) = greyvalue
                  bytes(currentline + (x * bpp) + 1) = greyvalue
                  bytes(currentline + (x * bpp) + 2) = greyvalue
               Next
            End Sub)

         Marshal.Copy(bytes, 0, ptrscan, bytes.Length)
         newbitmap.UnlockBits(bmdata)
         Return newbitmap
      End Function
   End Class
End Namespace
