﻿Option Strict On
Option Explicit On

Imports System.IO
Imports System.Drawing
Imports System.Threading
Imports System.Drawing.Imaging
Imports System.Runtime.InteropServices

Namespace exc.jdbi.vb.Pixelmanipulation
   Partial Public Class PixelManipulation
      Public Function FindColor(srcfile As String, col As Color, Optional _first As Boolean = True) As Point()
         Dim fi = New FileInfo(srcfile)
         If Not fi.Exists Then Throw New FileNotFoundException(NameOf(srcfile))
         Dim bm = ToBitmapFile(srcfile)
         Dim result = New List(Of Point)

         Dim bpp = Image.GetPixelFormatSize(bm.PixelFormat) \ 8
         Dim rc = New Rectangle(0, 0,
                                bm.Width,
                                bm.Height)
         Dim bmdata = bm.LockBits(rc,
                                ImageLockMode.ReadWrite,
                                bm.PixelFormat)
         Dim ptrscan = bmdata.Scan0

         Dim bytes = New Byte(bmdata.Stride * bmdata.Height - 1) {}
         Marshal.Copy(ptrscan, bytes, 0, bytes.Length)

         Dim cts = New CancellationTokenSource
         Dim token = cts.Token
         Dim options = New ParallelOptions With {.CancellationToken = token}

         Try
            Dim redc = col.R
            Dim bluec = col.B
            Dim greenc = col.G
            Dim alphac = col.A

            'positionyx = y * width * bbp + x * bbp
            Parallel.For(0, bmdata.Height, options,
               Sub(y)
                  If options.CancellationToken.IsCancellationRequested Then
                     Return
                  End If
                  Dim currentline = y * bmdata.Width * bpp
                  For x As Int32 = 0 To bmdata.Width - 1
                     If bytes(currentline + (x * bpp)) = bluec Then
                        If bytes(currentline + (x * bpp) + 1) = greenc Then
                           If bytes(currentline + (x * bpp) + 2) = redc Then
                              Dim bol = False
                              If bpp = 4 Then
                                 If bytes(currentline + (x * bpp) + 3) = alphac Then
                                    bol = True
                                 End If
                              Else bol = True
                              End If
                              If bol Then
                                 result.Add(New Point(x, y))
                                 If _first Then
                                    cts.Cancel()
                                    Return
                                 End If
                              End If
                           End If
                        End If
                     End If
                  Next
               End Sub)
         Catch ocex As OperationCanceledException
         Catch ex As Exception
         End Try
         Marshal.Copy(bytes, 0, ptrscan, bytes.Length)
         bm.UnlockBits(bmdata)
         If Not token.IsCancellationRequested Then
            cts.Cancel()
         End If
         cts.Dispose()
         Return result.ToArray
      End Function
   End Class
End Namespace


