﻿Option Strict On
Option Explicit On

Imports System.Drawing
Imports System.Drawing.Imaging
Imports System.Runtime.InteropServices
Imports SOCR = PixelManipulationVb.exc.jdbi.vb.Randoms.SOCR

Namespace exc.jdbi.vb.Pixelmanipulation
   Partial Public Class PixelManipulation
      Public Function ToRngBitmap(ByVal width As Integer, ByVal height As Integer) As Bitmap
         Return Me.ToRngBitmap(width, height, PixelFormat.Format32bppArgb)
      End Function
      Public Function ToRngBitmap(ByVal width As Integer, ByVal height As Integer, format As PixelFormat) As Bitmap
         Dim newbitmap = New Bitmap(width, height, format)
         Dim bpp = Image.GetPixelFormatSize(newbitmap.PixelFormat) \ 8
         Dim rc = New Rectangle(0, 0,
                                newbitmap.Width,
                                newbitmap.Height)
         Dim bmdata = newbitmap.LockBits(rc,
                                ImageLockMode.ReadWrite,
                                newbitmap.PixelFormat)
         Dim ptrscan = bmdata.Scan0

         Dim bytes = New Byte(bmdata.Stride * bmdata.Height - 1) {}

         Dim rngarr = New Byte(bytes.Length - 1) {}
         SOCR.NextBytes(rngarr)

         'positionyx = y * width * bbp + x * bbp
         Parallel.For(0, bmdata.Height,
            Sub(y)
               Dim currentline = y * bmdata.Width * bpp
               For x As Int32 = 0 To bmdata.Width - 1
                  bytes(currentline + (x * bpp)) = rngarr(currentline + (x * bpp))
                  bytes(currentline + (x * bpp) + 1) = rngarr(currentline + (x * bpp) + 1)
                  bytes(currentline + (x * bpp) + 2) = rngarr(currentline + (x * bpp) + 2)
                  If bpp = 4 Then bytes(currentline + (x * bpp) + 3) = 255
               Next
            End Sub)
         Marshal.Copy(bytes, 0, ptrscan, bytes.Length)
         newbitmap.UnlockBits(bmdata)
         Return newbitmap
      End Function
   End Class
End Namespace


