﻿Option Strict On
Option Explicit On

Imports System.IO
Imports System.Drawing
Imports System.ComponentModel

Namespace exc.jdbi.vb.Pixelmanipulation
   Partial Public Class PixelManipulation
      Public Shared Function Copy2(ByVal src As Bitmap) As Bitmap
         'Deep Clone (Funkst nicht für alles)
         Return src.Clone(New Rectangle(0, 0, src.Width, src.Height), src.PixelFormat)
      End Function

      Public Shared Function Copy(ByVal src As Bitmap) As Bitmap
         'https://www.vb-paradise.de/index.php/Thread/128594-Bitmap-in-einen-Byte-Array-konvertieren/
         Dim result As Bitmap
         Dim converter = TypeDescriptor.GetConverter(GetType(Image))
         Dim bytes = DirectCast(converter.ConvertTo(src, GetType(Byte())), Byte())

         Using ms = New MemoryStream(bytes)
            result = CType(Image.FromStream(ms), Bitmap)
         End Using

         'foreach (var p in src.PropertyItems)
         '  result.SetPropertyItem(p);
         Return result
      End Function

      Public Shared Function ToBitmapFile(ByVal srcfilepathname As String) As Bitmap
         Dim fi = New FileInfo(srcfilepathname)
         If Not fi.Exists Then Throw New FileNotFoundException(NameOf(srcfilepathname))

         Using fs = New FileStream(srcfilepathname, FileMode.Open)
            Return CType(Image.FromStream(fs, True, True), Bitmap)
         End Using
      End Function

      Public Shared Sub SaveBitmap(ByVal src As Bitmap, ByVal dstfilepathname As String, ByVal _deleteexist As Boolean)
         Dim fi = New FileInfo(dstfilepathname)
         If fi.Exists AndAlso _deleteexist Then fi.Delete()
         src.Save(dstfilepathname)
      End Sub
   End Class
End Namespace

