﻿Option Strict On
Option Explicit On
Imports System.IO
Imports exc.jdbi.Pixelmanipulation
Imports VBPM = PixelManipulationVb.exc.jdbi.vb.Pixelmanipulation.PixelManipulation

Public Class FrmMain
   Private Imgname As String = "pic1.png"
   Private Exedir As String = Path.GetDirectoryName(Application.ExecutablePath)
   Private Sub Button_Click(sender As Object, e As EventArgs) Handles _
      BtVbBLoad.Click, BtVbGLoad.Click, BtVbBClear.Click, BtVbGClear.Click,
      BtCsBLoad.Click, BtCsGLoad.Click, BtCsBClear.Click, BtCsGClear.Click
      Select Case True
         Case sender Is Me.BtVbBLoad : Me.LoadVbBasicPic()
         Case sender Is Me.BtVbGLoad : Me.LoadVbGreyPic()
         Case sender Is Me.BtVbBClear : Me.ClearVbBasicPic()
         Case sender Is Me.BtVbGClear : Me.ClearVbGreyPic()
         Case sender Is Me.BtCsBLoad : Me.LoadCsBasicPic()
         Case sender Is Me.BtCsGLoad : Me.LoadCsGreyPic()
         Case sender Is Me.BtCsBClear : Me.ClearCsBasicPic()
         Case sender Is Me.BtCsGClear : Me.ClearCsGreyPic()
      End Select
   End Sub
   Private Sub LoadVbBasicPic()
      If Me.PbVbBasic.Image IsNot Nothing Then
         Me.ClearVbBasicPic()
      End If

      Dim src = Path.Combine(Me.Exedir, Me.Imgname)
      Dim source = VBPM.ToBitmapFile(src)

      Me.PbVbBasic.Image = source
   End Sub
   Private Sub LoadCsBasicPic()
      If Me.PbCsBasic.Image IsNot Nothing Then
         Me.ClearCsBasicPic()
      End If
      Dim src = Path.Combine(Me.Exedir, Me.Imgname)
      Dim source = PixelManipulation.ToBitmapFile(src)

      Me.PbCsBasic.Image = source
   End Sub
   Private Sub LoadVbGreyPic()
      If Me.PbVbGrey.Image IsNot Nothing Then
         Me.ClearVbGreyPic()
      End If
      Dim src = Path.Combine(Me.Exedir, Me.Imgname)
      Dim source = VBPM.ToBitmapFile(src)

      Dim newbm As Bitmap = Nothing
      Dim pm = New VBPM

      Dim sw = New Stopwatch
      sw.Restart()
      Dim t = Task.Factory.StartNew(Sub() newbm = pm.ToGrayScale(source))
      t.Wait()
      t.Dispose()
      Me.PbVbGrey.Image = newbm
   End Sub
   Private Sub LoadCsGreyPic()
      If Me.PbCsGrey.Image IsNot Nothing Then
         Me.ClearCsGreyPic()
      End If
      Dim src = Path.Combine(Me.Exedir, Me.Imgname)
      Dim source = PixelManipulation.ToBitmapFile(src)

      Dim newbm As Bitmap = Nothing
      Dim pm = New PixelManipulation

      Dim sw = New Stopwatch
      sw.Restart()
      Dim t = Task.Factory.StartNew(Sub() newbm = pm.ToGrayScale(source))
      t.Wait()
      t.Dispose()
      Me.PbCsGrey.Image = newbm
   End Sub

   Private Sub ClearVbBasicPic()
      If Me.PbVbBasic.Image IsNot Nothing Then
         Me.PbVbBasic.Image.Dispose()
         Me.PbVbBasic.Image = Nothing
      End If
   End Sub
   Private Sub ClearCsBasicPic()
      If Me.PbCsBasic.Image IsNot Nothing Then
         Me.PbCsBasic.Image.Dispose()
         Me.PbCsBasic.Image = Nothing
      End If
   End Sub
   Private Sub ClearVbGreyPic()
      If Me.PbVbGrey.Image IsNot Nothing Then
         Me.PbVbGrey.Image.Dispose()
         Me.PbVbGrey.Image = Nothing
      End If
   End Sub
   Private Sub ClearCsGreyPic()
      If Me.PbCsGrey.Image IsNot Nothing Then
         Me.PbCsGrey.Image.Dispose()
         Me.PbCsGrey.Image = Nothing
      End If
   End Sub

   Private Sub CopyImagePic1()
      Dim di = New DirectoryInfo(Me.Exedir)
      Dim sdir = String.Empty
      Dim pdi = di, simg = "Image"
      While True
         pdi = di.Parent
         sdir = Path.Combine(pdi.FullName, simg)
         pdi = New DirectoryInfo(sdir)
         If pdi.Exists Then
            sdir = Path.Combine(pdi.FullName, Me.Imgname)
            Dim fi = New FileInfo(sdir)
            If fi.Exists Then
               sdir = Path.Combine(Me.Exedir, Me.Imgname)
               fi.CopyTo(sdir, True)
            End If
            Return
         End If
         di = pdi.Parent
      End While
   End Sub
   Private Sub InitializePictureBox()
      Me.CopyImagePic1()
      Me.LoadVbBasicPic()
      Me.LoadCsBasicPic()
   End Sub
   Public Sub New()
      MyBase.New
      Me.InitializeComponent()
      Me.InitializePictureBox()
   End Sub
End Class
